Option Explicit On

Imports System
Imports System.Text    ' <=== !
Imports System.Windows.Forms
Imports System.IO


Public Class Form1
    Dim anzahl As Integer
    Dim wertY, wertX As Integer
    Dim MeTop, MeLeft As Integer
    Dim ButCod As Integer = 1
    Dim t_zahl As Integer
    Dim ComVar, ComVarMov As String
    Dim daten As Byte

    'Codeabschnitt von Rod:

    Sub SendSerialData01xxxx(ByVal data As String)
        Dim enc As Encoding = Encoding.GetEncoding(1252)
        ' Send strings to a serial port.
        Using com1 As IO.Ports.SerialPort = _
        My.Computer.Ports.OpenSerialPort("COM1", 2400, IO.Ports.Parity.None, 8)
            com1.Encoding = enc
            com1.Write(data)
        End Using
    End Sub
    Sub SendSerialData02(ByVal data As String)
        Dim enc As Encoding = Encoding.GetEncoding(1252)
        ' Send strings to a serial port.
        'Using com1 As IO.Ports.SerialPort = _
        ' My.Computer.Ports.OpenSerialPort("COM1", 2400, IO.Ports.Parity.None, 8)
        SerialPort1.Encoding = enc
        SerialPort1.Write(data)
        'End Using
    End Sub
    Private Sub FindMySpecificString(ByVal searchString As String)
        ' Ensure we have a proper string to search for.
        If searchString <> String.Empty Then
            ' Find the item in the list and store the index to the item.
            Dim index As Integer = ListBox1.FindStringExact(searchString)
            ' Determine if a valid index is returned. Select the item if it is valid.
            If index <> ListBox.NoMatches Then
                ListBox1.SetSelected(index, True)
            Else
                MessageBox.Show("The search string did not find any items in the ListBox that exactly match the specified search string")
            End If
        End If
    End Sub
    Public Function PortTest(ByVal COMPortNummer As Integer) As Boolean

        Dim SerialPort1 = "COM1"
        SerialPort1.CommPort = COMPortNummer
        On Error Resume Next
        SerialPort1.PortOpen = True

        'If Err() = 0 Then
        If 1 = 0 Then
            PortTest = True
            SerialPort1.PortOpen = False
        Else
            PortTest = False
            SerialPort1.PortOpen = False
        End If
    End Function
    Public Sub PoTest()
        Dim Portzaehler As Integer
        For Portzaehler = 1 To 16
            If PortTest(Portzaehler) Then
                MsgBox("COM" + Str(Portzaehler) + " verfgbar")
            End If
        Next
    End Sub

    Private Sub GetSerialPortNames()
        ' Show all available COM ports.
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ListBox1.Items.Add(sp)
        Next
        ' TextBox1.Text = ListBox1.Items.Count
        Try

        Catch ex As Exception

        End Try
        TextBox2.Text = ListBox1.FindString(ComVar)
        ' If ComVar = Str(-1) Then
        If ComVar <> String.Empty Then
            '       MsgBox("" & ComVar & "  " & ListBox1.FindString(ComVar))
        End If
        ' ListBox1.Items.Remove(ListBox1.Text)
        '     ListBox1.Items(1)
        If ListBox1.FindString(ComVar) = -1 Then

            TextBox13.BackColor = Color.Red
            TextBox13.Text = ComVar
            MsgBox("Com nicht vorhanden " & ComVar)

        Else
            TextBox13.Text = ComVar
            'SerialPort1.Close()
            SerialPort1.PortName = ComVar
            'SerialPort1.Open()
        End If

        ' SerialPort1.DiscardInBuffer()
        ' SerialPort1.DiscardOutBuffer()


    End Sub


    '#############################################################################
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        MeTop = 30 : MeLeft = 30
        Me.Top = MeTop
        Me.Left = MeLeft
        Me.Text = " PrimitivProgramm Rs232 Byte Senden / Byte empfangen"
        '  SerialPort1.DiscardInBuffer()
        ' SerialPort1.DiscardOutBuffer()
        SerialPort1.ReceivedBytesThreshold = 1
        CheckForIllegalCrossThreadCalls = False

        'ComVar = "COM3"
        ComVar = My.Settings.ComVar '   wert auslesen
        'SerialPort1.Open()
        GetSerialPortNames()

        TextBox14.Text = "Baud  " & My.Settings.BAUD '   wert auslesen
        SerialPort1.BaudRate = My.Settings.BAUD '   wert auslesen

        ' ComVar = ListBox1.Items(za)
        ' If SerialPort1.existent() Then
        ' If SerialPort1.CDHolding = True Then

        ' myIniFile = "Test\test.ini"

        'SerialPort1.Open()
        ' ListBox1.Text = GetSerialPortNames()    'lesen aller ausgnge
        '  If SerialPort1.IsOpen() Then
        'MsgBox("Ser.Port " & SerialPort1.PortName & " offen")

        ListBox2.Items.Clear()
        ListBox2.Items.Add("1200")
        ListBox2.Items.Add("2400")
        ListBox2.Items.Add("4800")
        ListBox2.Items.Add("9600")
        ListBox2.Items.Add("19200")
        ListBox2.Items.Add("38400")
        ListBox2.Items.Add("115200")

    End Sub
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        SerialPort1.Close()
    End Sub
    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        t_zahl = t_zahl + 1
        If t_zahl = 100 Then t_zahl = 0

        ' daten = SerialPort1.ReadByte()
        ' Label2.Text = Hex(daten)
        TextBox2.Text = t_zahl
        ' Timer2.Enabled = False
        byteeinlesen()
    End Sub

    Private Sub byteeinlesen()
        daten = SerialPort1.ReadByte()
        Timer2.Enabled = True
        Try
        Catch ex As Exception
            MsgBox("fehler ")
        End Try
    End Sub
    Private Sub Timer2_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Label1.Text = "Empfang  " & daten
        '     Label1.Text = Hex(daten)
        '     Timer2.Enabled = False
    End Sub
    Private Sub SerialPort1_ErrorReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialErrorReceivedEventArgs) Handles SerialPort1.ErrorReceived
        MsgBox("Lesefehler")
    End Sub
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        byte_senden()
    End Sub
    Private Sub byte_senden()
        SendSerialData02(Chr(VScrollBar1.Value))
        Label2.Text = "Senden " & VScrollBar1.Value
    End Sub
    Private Sub VScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles VScrollBar1.Scroll
        Dim werte As Byte
        werte = VScrollBar1.Value
        TextBox1.Text = werte
    End Sub
    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            CheckBox1.Text = "Senden Ein"
            SerialPort1.Close()
            SerialPort1.Open()
            Timer1.Enabled = True
        Else
            CheckBox1.Text = "Senden Aus"
            Timer1.Enabled = False
        End If
    End Sub
    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        If CheckBox2.Checked = True Then
            CheckBox2.Text = "Empfang Ein"
            'SerialPort1.Close()
            'SerialPort1.Open()
            Timer2.Enabled = True
        Else
            CheckBox2.Text = "Empfang Aus"
            Timer2.Enabled = False
        End If
    End Sub
    Private Sub ListBox1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox1.DoubleClick
        Dim za As Integer
        za = ListBox1.SelectedIndex
        ComVar = ListBox1.Items(za)
        My.Settings.ComVar = ComVar '   variable speichern

        TextBox13.BackColor = Color.White
        TextBox13.Text = ListBox1.Items(za)

        SerialPort1.Close()
        SerialPort1.PortName = ComVar
        SerialPort1.Open()
    End Sub
    Private Function GetItemText(ByVal i As Integer) As String
        Return ListBox1.Items(i).ToString
    End Function
    Private Sub ListBox2_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox2.DoubleClick
        Dim za As Integer
        za = ListBox2.SelectedIndex
        TextBox14.Text = "Baud  " & ListBox2.Items(za)
        SerialPort1.BaudRate = ListBox2.Items(za)
        My.Settings.BAUD = ListBox2.Items(za) '   variable speichern
    End Sub
End Class

